pcl::CorrespondenceGrouping< PointModelT, PointSceneT > Class Template Referenceabstract
Module recognition

Abstract base class for Correspondence Grouping algorithms. More...

`#include <pcl/recognition/cg/correspondence_grouping.h>`

Inheritance diagram for pcl::CorrespondenceGrouping< PointModelT, PointSceneT >:

## Public Types

typedef pcl::PointCloud< PointSceneT > | SceneCloud
typedef SceneCloud::Ptr | SceneCloudPtr
typedef SceneCloud::ConstPtr | SceneCloudConstPtr
Public Types inherited from pcl::PCLBase< PointModelT >
typedef pcl::PointCloud< PointModelT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| CorrespondenceGrouping ()
| Empty constructor. More...
virtual | ~CorrespondenceGrouping ()
| destructor. More...
virtual void | setSceneCloud (const SceneCloudConstPtr &scene)
| Provide a pointer to the scene dataset. More...
SceneCloudConstPtr | getSceneCloud () const
| Getter for the scene dataset. More...
virtual void | setModelSceneCorrespondences (const CorrespondencesConstPtr &corrs)
| Provide a pointer to the precomputed correspondences between points in the input dataset and points in the scene dataset. More...
CorrespondencesConstPtr | getModelSceneCorrespondences () const
| Getter for the precomputed correspondences between points in the input dataset and points in the scene dataset. More...
std::vector< double > | getCharacteristicScales () const
| Getter for the vector of characteristic scales associated to each cluster. More...
void | cluster (std::vector< Correspondences > &clustered_corrs)
| Clusters the input correspondences belonging to different model instances. More...
Public Member Functions inherited from pcl::PCLBase< PointModelT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointModelT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual void | clusterCorrespondences (std::vector< Correspondences > &clustered_corrs)=0
| The actual clustering method, should be implemented by each subclass. More...
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...
Protected Member Functions inherited from pcl::PCLBase< PointModelT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

SceneCloudConstPtr | scene_
| The scene cloud. More...
CorrespondencesConstPtr | model_scene_corrs_
| The correspondences between points in the input and the scene datasets. More...
std::vector< double > | corr_group_scale_
| characteristic scale associated to each correspondence subset; if the cg algorithm can not handle scale invariance, the size of the vector will be 0. More...
Protected Attributes inherited from pcl::PCLBase< PointModelT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointModelT, typename PointSceneT>
class pcl::CorrespondenceGrouping< PointModelT, PointSceneT >

Abstract base class for Correspondence Grouping algorithms.

Author
  Tommaso Cavallari, Federico Tombari, Aitor Aldoma

Definition at line 55 of file correspondence_grouping.h.

## Member Typedef Documentation

template<typename PointModelT, typename PointSceneT>

typedef pcl::PointCloud<PointSceneT> pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::SceneCloud

Definition at line 58 of file correspondence_grouping.h.

template<typename PointModelT, typename PointSceneT>

typedef SceneCloud::ConstPtr pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::SceneCloudConstPtr

Definition at line 60 of file correspondence_grouping.h.

template<typename PointModelT, typename PointSceneT>

typedef SceneCloud::Ptr pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::SceneCloudPtr

Definition at line 59 of file correspondence_grouping.h.

## Constructor & Destructor Documentation

template<typename PointModelT, typename PointSceneT>

pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::CorrespondenceGrouping | ( |  | ) |

inline

Empty constructor.

Definition at line 63 of file correspondence_grouping.h.

template<typename PointModelT, typename PointSceneT>

virtual pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::~CorrespondenceGrouping | ( |  | ) |

inline virtual

destructor.

Definition at line 66 of file correspondence_grouping.h.

References pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::model_scene_corrs_, and pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::scene_.

## Member Function Documentation

template<typename PointModelT , typename PointSceneT >

void pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::cluster | ( | std::vector< Correspondences > & | clustered_corrs | ) |

Clusters the input correspondences belonging to different model instances.

Parameters

  [out] | clustered_corrs | a vector containing the correspondences for each instance of the model found within the input data.

Definition at line 44 of file correspondence_grouping.hpp.

Referenced by pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::getCharacteristicScales().

template<typename PointModelT, typename PointSceneT>

virtual void pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::clusterCorrespondences | ( | std::vector< Correspondences > & | clustered_corrs | ) |

protected pure virtual

The actual clustering method, should be implemented by each subclass.

Parameters

  [out] | clustered_corrs | a vector containing the correspondences for each instance of the model found within the input data.

Implemented in pcl::Hough3DGrouping< PointModelT, PointSceneT, PointModelRfT, PointSceneRfT >, and pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >.

template<typename PointModelT, typename PointSceneT>

bool pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::deinitCompute | ( |  | ) |

inline protected

This method should get called after finishing the actual computation.

Definition at line 192 of file correspondence_grouping.h.

template<typename PointModelT, typename PointSceneT>

std::vector<double> pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::getCharacteristicScales | ( |  | ) | const

inline

Getter for the vector of characteristic scales associated to each cluster.

Returns
  the vector of characteristic scales (assuming scale = model / scene)

Definition at line 120 of file correspondence_grouping.h.

References pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::cluster(), and pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::corr_group_scale_.

template<typename PointModelT, typename PointSceneT>

CorrespondencesConstPtr pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::getModelSceneCorrespondences | ( |  | ) | const

inline

Getter for the precomputed correspondences between points in the input dataset and points in the scene dataset.

Returns
  the correspondences between the model and the scene.

Definition at line 110 of file correspondence_grouping.h.

References pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::model_scene_corrs_.

template<typename PointModelT, typename PointSceneT>

SceneCloudConstPtr pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::getSceneCloud | ( |  | ) | const

inline

Getter for the scene dataset.

Returns
  the const boost shared pointer to a PointCloud message.

Definition at line 87 of file correspondence_grouping.h.

References pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::scene_.

template<typename PointModelT, typename PointSceneT>

bool pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::initCompute | ( |  | ) |

inline protected

This method should get called before starting the actual computation.

Internally, initCompute() does the following:

- checks if an input dataset is given, and returns false otherwise
- checks if a scene dataset is given, and returns false otherwise
- checks if the model-scene correspondences have been given, and returns false otherwise

Definition at line 160 of file correspondence_grouping.h.

References pcl::PCLBase< PointModelT >::input_.

template<typename PointModelT, typename PointSceneT>

virtual void pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::setModelSceneCorrespondences | ( | const CorrespondencesConstPtr & | corrs | ) |

inline virtual

Provide a pointer to the precomputed correspondences between points in the input dataset and points in the scene dataset.

The correspondences are going to be clustered into different model hypotheses by the algorithm.

Parameters

  [in] | corrs | the correspondences between the model and the scene.

Reimplemented in pcl::Hough3DGrouping< PointModelT, PointSceneT, PointModelRfT, PointSceneRfT >.

Definition at line 99 of file correspondence_grouping.h.

References pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::model_scene_corrs_.

template<typename PointModelT, typename PointSceneT>

virtual void pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::setSceneCloud | ( | const SceneCloudConstPtr & | scene | ) |

inline virtual

Provide a pointer to the scene dataset.

Parameters

  [in] | scene | the const boost shared pointer to a PointCloud message.

Reimplemented in pcl::Hough3DGrouping< PointModelT, PointSceneT, PointModelRfT, PointSceneRfT >.

Definition at line 77 of file correspondence_grouping.h.

References pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::scene_.

## Member Data Documentation

template<typename PointModelT, typename PointSceneT>

std::vector<double> pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::corr_group_scale_

protected

characteristic scale associated to each correspondence subset; if the cg algorithm can not handle scale invariance, the size of the vector will be 0.

Definition at line 143 of file correspondence_grouping.h.

Referenced by pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::getCharacteristicScales().

template<typename PointModelT, typename PointSceneT>

CorrespondencesConstPtr pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::model_scene_corrs_

protected

The correspondences between points in the input and the scene datasets.

Definition at line 139 of file correspondence_grouping.h.

Referenced by pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::getModelSceneCorrespondences(), pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::setModelSceneCorrespondences(), and pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::~CorrespondenceGrouping().

template<typename PointModelT, typename PointSceneT>

SceneCloudConstPtr pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::scene_

protected

The scene cloud.

Definition at line 134 of file correspondence_grouping.h.

Referenced by pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::getSceneCloud(), pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::setSceneCloud(), and pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::~CorrespondenceGrouping().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/recognition/include/pcl/recognition/cg/correspondence_grouping.h
- /build/pcl-0nnAvv/pcl-1.7.2/recognition/include/pcl/recognition/impl/cg/correspondence_grouping.hpp